//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UtJuego3Raya.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

void tJuego3Raya::aplicaJugada(unsigned int c, unsigned int f) throw(EJuego)
{
        if((tablero != NULL) && sePuede(c,f))
        {
                tablero->setElem(c, f, turno);
                libres--;
                hayGanador = fin();
                if(!hayGanador)
                {
                        if(turno == Ja)
                        {
                                turno = Jb;
                        }
                        else turno = Ja;
                }
        }
        else throw EJuego();
} //: mtodo abstracto que aplica la jugada caracterizada por la posicin (c,f) del tablero. Si dicha jugada no es legal se lanza una excepcin.

bool tJuego3Raya::sePuede(unsigned int c, unsigned int f) const throw()
{
        try
        {
                Turno aux;
                tablero->getElem(c, f, aux);
                return aux == Jn;
        }
        catch (ErrRango)
        {
                return false;
        }
} // : dice si la jugada caracterizada por (c,f) es una jugada legal.

bool tJuego3Raya::fin() const throw()
{
        if((libres > 0) && !hayGanador)
        {
                Turno a1, a2, a3;
                unsigned int i = 0;
                bool ganador = false;
                while(!ganador && (i < 3))
                {
                        tablero->getElem(i, 0, a1);
                        tablero->getElem(i, 1, a2);
                        tablero->getElem(i, 2, a3);
                        if((a1 == a2) && (a1 == a3) && (a1 != Jn))
                        {
                                ganador = true;
                        }
                        else
                        {
                                tablero->getElem(0, i, a1);
                                tablero->getElem(1, i, a2);
                                tablero->getElem(2, i, a3);
                                if((a1 == a2) && (a1 == a3) && (a1 != Jn))
                                {
                                        ganador = true;
                                }
                        }
                        ++i;
                }
                if(!ganador)
                {
                        tablero->getElem(0, 0, a1);
                        tablero->getElem(1, 1, a2);
                        tablero->getElem(2, 2, a3);
                        if((a1 == a2) && (a1 == a3) && (a1 != Jn))
                        {
                                ganador = true;
                        }
                        else
                        {
                                tablero->getElem(0, 2, a1);
                                tablero->getElem(1, 1, a2);
                                tablero->getElem(2, 0, a3);
                                if((a1 == a2) && (a1 == a3) && (a1 != Jn))
                                {
                                        ganador = true;
                                }
                        }
                }
                return ganador;
        }
        else return true;
} //: indica si no se pueden realizar ms jugadas.

tJuegoLogT2* tJuego3Raya::clona() const
{
        return new tJuego3Raya(*this);
} //: devuelve un puntero a una copia del juego actual.
