//---------------------------------------------------------------------------

#ifndef UtJuego3RayaH
#define UtJuego3RayaH

#include "UtJuegoLogT2.h"
//---------------------------------------------------------------------------

class tJuego3Raya:public tJuegoLogT2
{
public:
        tJuego3Raya(const tJuego3Raya& juego):tJuegoLogT2(juego) {this->libres = juego.libres;};
        tJuego3Raya(Turno t = Ja):tJuegoLogT2(3, 3, t) {libres = 9;};

        virtual void aplicaJugada(unsigned int c, unsigned int f) throw(EJuego); //: mtodo abstracto que aplica la jugada caracterizada por la posicin (c,f) del tablero. Si dicha jugada no es legal se lanza una excepcin.
        virtual bool sePuede(unsigned int c, unsigned int f) const throw(); // : dice si la jugada caracterizada por (c,f) es una jugada legal.
        virtual bool fin() const throw(); //: indica si no se pueden realizar ms jugadas.
        virtual tJuegoLogT2* clona() const; //: devuelve un puntero a una copia del juego actual.

private:
        int libres;
};

#endif
