//---------------------------------------------------------------------------

#ifndef UtJugadorAut3RH
#define UtJugadorAut3RH

#include "UtJugadorAutT2.h"
#include "UtArbolJT2.h"
#include "UtJuego3Raya.h"
//---------------------------------------------------------------------------

class tJugadorAut3R: public tJugadorAutT2
{
public:
        tJugadorAut3R() {};
        ~tJugadorAut3R() {};
        virtual Casilla juega(const tJuegoLogT2& EJ) throw (EJugador) = 0;
};

class tJugAlea3R: public tJugadorAut3R
{
public:
        tJugAlea3R() {};
        ~tJugAlea3R() {};
        virtual Casilla juega(const tJuegoLogT2& EJ) throw (EJugador);
};

typedef int (*FunHeuristica3R)(const tJuego3Raya&);

int heuris3R (const tJuego3Raya& EJ);
void heurisAux3R(int& cont, Turno a1, Turno a2, Turno a3);

class tJugConz3R: public tJugadorAut3R
{
public:
        tJugConz3R(int nivel = 2) {this->nivel = nivel; heuristica = heuris3R;};
        ~tJugConz3R() {};
        virtual Casilla juega(const tJuegoLogT2& EJ) throw (EJugador);

private:
        int nivel;
        FunHeuristica3R heuristica;
};


#endif
