//---------------------------------------------------------------------------

#ifndef UtArbolH
#define UtArbolH

#include "UtLista.h"
//---------------------------------------------------------------------------

template <class T> class Arbol
{
public:
        Arbol(const T& D) {elem = D;};
        ~Arbol() {};
        unsigned int numHijos() const throw() {return hijos.size();};
        virtual bool esHoja() const throw() {return (hijos.size() == 0);};
        const T& getDato() const throw() {return elem;};
        Arbol* getHijo(int i) const throw(ErrRango) {return hijos.at(i);};
        void addHijo(Arbol* arbol) throw (bad_alloc) {hijos.push_back(arbol);};

protected:
        T elem;
        Lista<Arbol*> hijos;
};

#endif
