//---------------------------------------------------------------------------

#ifndef UtInterfazGrafOtH
#define UtInterfazGrafOtH

#include "UtInterfazGrafT2.h"
#include "UtJuegoOtelo.h"
//---------------------------------------------------------------------------

class tInterfazGrafOt: public tInterfazGrafT2
{
public:
        tInterfazGrafOt(TCanvas* l = NULL):tInterfazGrafT2(l) {};
        ~tInterfazGrafOt() {};
        static tBMP fichaA, fichaB, fichaN, barraPaso;
        static const int ladoCasilla = 41;
        static const int altoTablero = 328;
        static const int anchoTablero = 369;

        virtual unsigned int dameColumna(unsigned int X) const throw (EInterfaz) {return X / ladoCasilla;}; // devuelve la columna del tablero correspondiente a la coordenada X.
        virtual unsigned int dameFila(unsigned int Y) const throw (EInterfaz) {return Y / ladoCasilla;}; // devuelve la fila del tablero correspondiente a la coordenada Y.
        virtual unsigned int dameAnchoGraf() const throw() {return anchoTablero;}; // devuelve el ancho total que utiliza muestraEstado.
        virtual unsigned int dameAltoGraf() const throw() {return altoTablero;}; // anlogo al anterior.

        virtual void muestraEstado(const tJuegoLogT2& EJ) const throw (EInterfaz); // dibuja en lienzo el estado del juego EJ.
};
#endif
