//---------------------------------------------------------------------------

#ifndef UtInterfazGrafT2H
#define UtInterfazGrafT2H

#include "UtJuegoLogT2.h"
//---------------------------------------------------------------------------

class tInterfazGrafT2
{
public:
        tInterfazGrafT2(TCanvas* l = NULL) {lienzo = l;};
        ~tInterfazGrafT2() {};

        virtual unsigned int dameColumna(unsigned int X) const throw (EInterfaz) = 0; // devuelve la columna del tablero correspondiente a la coordenada X.
        virtual unsigned int dameFila(unsigned int Y) const throw (EInterfaz) = 0; // devuelve la fila del tablero correspondiente a la coordenada Y.
        Casilla dameCasilla(unsigned int X, unsigned int Y) const throw (EInterfaz); // devuelve la casilla del tablero correspondiente a las coordenadas X e Y.
        virtual void muestraEstado(const tJuegoLogT2& EJ) const throw (EInterfaz) = 0; // dibuja en lienzo el estado del juego EJ.
        virtual unsigned int dameAnchoGraf() const throw() = 0; // devuelve el ancho total que utiliza muestraEstado.
        virtual unsigned int dameAltoGraf() const throw() = 0; // anlogo al anterior.

protected:
        TCanvas* lienzo;
};

class tBMP
{
public:
        Graphics::TBitmap* bmp;
        tBMP() {bmp= new Graphics::TBitmap();};
        tBMP(AnsiString Bmp) {bmp= new Graphics::TBitmap(); bmp->LoadFromFile(Bmp);};
        ~tBMP() {delete bmp; bmp=NULL;};
        void cargar(AnsiString Bmp){bmp->LoadFromFile(Bmp);};
        Graphics::TBitmap* BMP(){return bmp;};
};

#endif
