//---------------------------------------------------------------------------

#ifndef tForPrincpH
#define tForPrincpH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>

#include "UtJugadorAutC4.h"
#include "UtInterfazGrafC4.h"
#include "UtJuegoConecta4.h"
#include "UtJugadorAut3R.h"
#include "UtInterfazGraf3R.h"
#include "UtJuego3Raya.h"
#include "UtJugadorAutOt.h"
#include "UtInterfazGrafOt.h"
#include "UtJuegoOtelo.h"
#include "UColaIter.h"
#include "UtListaOrd.h"
#include <Dialogs.hpp>
#include <iostream>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------

enum enuJuego{ninguno, conect4, tresER, otelo};
enum enuJugador{otro, alea, cnzudo};
enum enuNivel{bajo=2, medio=4, alto=6};

class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TMainMenu *MainMenu1;
        TMenuItem *Juego1;
        TMenuItem *Jugador1;
        TMenuItem *Partida1;
        TMenuItem *Conecta41;
        TMenuItem *Aleatorio1;
        TMenuItem *Iniciar2;
        TMenuItem *Usuario1;
        TMenuItem *Ordenador1;
        TMenuItem *Salir2;
        TMenuItem *Guardar1;
        TMenuItem *Cargar1;
        TMenuItem *Deshacer1;
        TMenuItem *OtraVentana1;
        TMenuItem *Concienzudo1;
        TMenuItem *Bajo1;
        TMenuItem *Medio1;
        TMenuItem *Alto1;
        TMenuItem *GuardarComo1;
        TOpenDialog *OpenDlg;
        TSaveDialog *SaveDlg;
        TMenuItem *TresenRaya1;
        TMenuItem *Otello1;
        TMenuItem *N1;
        TMenuItem *Dosjugadores1;
        void __fastcall FormMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall Conecta41Click(TObject *Sender);
        void __fastcall Aleatorio1Click(TObject *Sender);
        void __fastcall Usuario1Click(TObject *Sender);
        void __fastcall FormPaint(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall Ordenador1Click(TObject *Sender);
        void __fastcall Salir2Click(TObject *Sender);
        void __fastcall Deshacer1Click(TObject *Sender);
        void __fastcall GuardarComo1Click(TObject *Sender);
        void __fastcall Guardar1Click(TObject *Sender);
        void __fastcall OtraVentana1Click(TObject *Sender);
        void __fastcall Cargar1Click(TObject *Sender);
        void __fastcall Bajo1Click(TObject *Sender);
        void __fastcall Medio1Click(TObject *Sender);
        void __fastcall Alto1Click(TObject *Sender);
        void __fastcall TresenRaya1Click(TObject *Sender);
        void __fastcall Otello1Click(TObject *Sender);
        void __fastcall Dosjugadores1Click(TObject *Sender);
private:	// User declarations
        tJuegoLogT2 *partida, *backup;
        tInterfazGrafT2 *interfaz;
        tJugadorAutT2 *jugador;
        bool configuradoP, configuradoJ, jugando, dosJug;
        enuJuego juego;
        enuJugador jugon;
        enuNivel nivel;
        void destroyForm(TForm1* form);
        void iniciaPartida(Turno t);
        AnsiString nomFich;
        ColaIter<Casilla> jugadas;
        Turno primero;
        static bool Orden(TForm1* a, TForm1* b) {return a < b;};
        ListaOrd<TForm1*, TForm1::Orden> lista;
        void reset();
public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
